/* A RapidNet application. Generated by RapidNet compiler. */

#ifndef SIMLSPERIODIC_H
#define SIMLSPERIODIC_H

#include <string>
#include <iostream>
#include "ns3/ptr.h"
#include "ns3/event-id.h"
#include "ns3/ipv4-address.h"
#include "ns3/rapidnet-header.h"
#include "ns3/relation-base.h"
#include "ns3/database.h"
#include "ns3/discovery.h"
#include "ns3/aggregator.h"
#include "ns3/aggwrap.h"

using namespace std;
using namespace ns3;
using namespace ns3::rapidnet::discovery;

namespace ns3 {

class Socket;
class Packet;

namespace rapidnet {
namespace simlsperiodic {

class SimLsPeriodic : public Discovery
{
public:
  static const string ELSU;
  static const string ELSUCHANGE;
  static const string ELSUCOUNT;
  static const string ELSULOC;
  static const string ELINKADD;
  static const string ELINKCOUNT;
  static const string LINK;
  static const string PERIODIC;
  static const string R11_ECAPERIODIC;
  static const string R12_ECAPERIODIC;
  static const string TLSU;
  static const string TLINK;

  static TypeId GetTypeId (void);

  SimLsPeriodic ();

  virtual ~SimLsPeriodic ();

protected:

  virtual void DoDispose (void);

  virtual void StartApplication (void);

  virtual void StopApplication (void);

  virtual void InitDatabase (void);

  virtual void DemuxRecv (Ptr<Tuple> tuple);

  virtual void R01Eca0Ins (Ptr<Tuple> link);

  virtual void R01Eca0Ref (Ptr<Tuple> link);

  virtual void R02_eca (Ptr<Tuple> eLinkAdd);

  virtual void R03_eca (Ptr<Tuple> eLinkCount);

  virtual void R04_eca (Ptr<Tuple> eLinkAdd);

  virtual void R11_ecaperiodic ();

  virtual void R11_eca (Ptr<Tuple> r11_ecaperiodic);

  virtual void R12_ecaperiodic ();

  virtual void R12_eca (Ptr<Tuple> r12_ecaperiodic);

  virtual void R21_eca (Ptr<Tuple> eLSU);

  virtual void R22_eca (Ptr<Tuple> eLSULoc);

  virtual void R23_eca (Ptr<Tuple> eLSUCount);

  virtual void R24_eca (Ptr<Tuple> eLSULoc);

  virtual void R31Eca0Ins (Ptr<Tuple> tLSU);

  virtual void R31Eca0Ref (Ptr<Tuple> tLSU);

  virtual void R32_eca (Ptr<Tuple> eLSUChange);

  EventId m_event_r11_ecaperiodic;
  EventId m_event_r12_ecaperiodic;
};

} // namespace simlsperiodic
} // namespace rapidnet
} // namespace ns3

#endif // SIMLSPERIODIC_H
